#!/usr/bin/perl

@langs=("en","de","fr");

#generate the strings beforehand
#the output will maintain same orders 
# even though the formats are different.
#this makes them as equal as possible.
my(%db);
my(@keys,$i,$j,$key,$val,$lang);

for($i=1;$i<=500;$i++)
{
	$key = gen_key();
	push(@keys,$key);
	for($j=0;$j<=$#langs;$j++)
	{
		$db{$langs[$j]}->{$key} = gen_val();
	}
}

#generate AMX Mod X file
open(AMXX, ">fakedict-amxmodx.txt");
for($j=0;$j<=$#langs;$j++)
{
	print AMXX "[".$langs[$j]."]\n";
	$lang=$langs[$j];
	my(%h);
	%h=%{$db{$lang}};
	for($i=0;$i<=$#keys;$i++)
	{
		print AMXX $keys[$i]." = ".$h{$keys[$i]}."\n";
	}
}
close(AMXX);

#generate AMX Mod file
open(AMX, ">fakedict-amxmod.txt");
for($j=0;$j<=$#keys;$j++)
{
	$key=$keys[$j];
	print AMX "\"$key\"\n";
	for($i=1;$i<=$#langs;$i++)
	{
		$lang=$langs[$i];
		print AMX "$lang:\"".$db{$lang}->{$key}."\"\n";
	}
	print AMX "\n";
}
close(AMX);

print "String database generated as fakedict-amxmod.txt and fakedict-amxmodx.txt\n";

sub gen_key
{
  my($length,$str);
  $length = int(rand(14)) + 3;
  while ($length--)
  {
     $str .= chr(rand(26) + 65);
  }
  return $str;
}

sub gen_val
{
  my($length,$str);
  $length = int(rand(80)) + 3;
  while ($length--)
  {
     $str .= chr(rand(26) + 65);
  }
  return $str;
}
